/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smartDEN_Notifier_MQTT;

import java.awt.Component;
import java.math.BigInteger;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import org.eclipse.paho.client.mqttv3.IMqttDeliveryToken;
import org.eclipse.paho.client.mqttv3.MqttCallback;
import org.eclipse.paho.client.mqttv3.MqttClient;
import org.eclipse.paho.client.mqttv3.MqttException;
import org.eclipse.paho.client.mqttv3.MqttMessage;
import static smartDEN_Notifier_MQTT.smartDEN_Notifier_MQTTView.aiPanel;
import static smartDEN_Notifier_MQTT.smartDEN_Notifier_MQTTView.datetimeLabel;
import static smartDEN_Notifier_MQTT.smartDEN_Notifier_MQTTView.deviceLabel;
import static smartDEN_Notifier_MQTT.smartDEN_Notifier_MQTTView.diName1;
import static smartDEN_Notifier_MQTT.smartDEN_Notifier_MQTTView.diName2;
import static smartDEN_Notifier_MQTT.smartDEN_Notifier_MQTTView.diPanel;
import static smartDEN_Notifier_MQTT.smartDEN_Notifier_MQTTView.notificationLabel;
import static smartDEN_Notifier_MQTT.smartDEN_Notifier_MQTTView.startButton;
import static smartDEN_Notifier_MQTT.smartDEN_Notifier_MQTTView.statusMessageLabel;
import static smartDEN_Notifier_MQTT.smartDEN_Notifier_MQTTView.stopButton;
import static smartDEN_Notifier_MQTT.smartDEN_Notifier_MQTTView.tiPanel;

/**
 *
 * @author LenovoD
 */
public class MyMqtt implements MqttCallback {

    static MqttClient client;
    String notificationsTopic;
    String readTopic;

    public static String getMD5(String input) {
        try {
            MessageDigest md = MessageDigest.getInstance("MD5");
            byte[] messageDigest = md.digest(input.getBytes());
            BigInteger number = new BigInteger(1, messageDigest);
            String hashtext = number.toString(16);
            // Now we need to zero pad it if you actually want the full 32 chars.
            while (hashtext.length() < 32) {
                hashtext = "0" + hashtext;
            }
            return hashtext;
        } catch (NoSuchAlgorithmException e) {
            throw new RuntimeException(e);
        }
    }

    public void readFromTopic() {
        try {
            readTopic = getMD5(smartDEN_Notifier_MQTTView.macText.getText() + "adminwrite" + smartDEN_Notifier_MQTTView.passwordText.getText());
            notificationsTopic = getMD5(smartDEN_Notifier_MQTTView.macText.getText() + "adminnotifications" + smartDEN_Notifier_MQTTView.passwordText.getText());
            client = new MqttClient("tcp://" + smartDEN_Notifier_MQTTView.brokerText.getText() + ":" + smartDEN_Notifier_MQTTView.portText.getText(), "_1234567890125");
            client.connect();
            client.setCallback(this);
            client.subscribe(readTopic);
            client.subscribe(notificationsTopic);
            System.out.println("Subscribed to read topic.");
            statusMessageLabel.setText("");
        } catch (Exception e) {
            //e.printStackTrace();
            System.out.println("Failed to subscribe to read topic.");
            statusMessageLabel.setText("Error occured. Check MQTT Settings and/or Internet Connection.");
            startButton.setEnabled(true);
            stopButton.setEnabled(false);
        }
    }

    public static void Publish() {
        String publishTopic = getMD5(smartDEN_Notifier_MQTTView.macText.getText() + "adminread" + smartDEN_Notifier_MQTTView.passwordText.getText());
        final MqttMessage message = new MqttMessage();
        message.setPayload("MQTT_COMMAND?GETSTATUS;".getBytes());
        try {
            client.publish(publishTopic, message);
            System.out.println(message.toString());
            statusMessageLabel.setText("");
        } catch (Exception ex) {
            statusMessageLabel.setText("Error occured. Check MQTT Settings and/or Internet Connection.");
            startButton.setEnabled(true);
            stopButton.setEnabled(false);
        }
    }

    public void connectionLost(Throwable thrwbl) {
        //throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
        System.out.println("Connection Lost");
        thrwbl.printStackTrace();
    }

    public void messageArrived(String topic, MqttMessage mm) throws Exception {
        String reply = new String(mm.getPayload());
        System.out.println(reply);
        if (topic.equals(readTopic)) {
            Component[] components = diPanel.getComponents();
            for (int i = 1; i < 17; i++) {
                String name = "diName" + i;
                for (Component child : components) {
                    if (child instanceof JLabel) {
                        JLabel label = (JLabel) child;
                        if (name.equals(label.getName())) {
                            label.setText(getValueOfXML(reply, "DigitalInput" + i, "Name"));;
                            break;
                        }
                    }
                }
                String value = "diValue" + i;
                for (Component child : components) {
                    if (child instanceof JLabel) {
                        JLabel label = (JLabel) child;
                        if (value.equals(label.getName())) {
                            label.setText(getValueOfXML(reply, "DigitalInput" + i, "Value"));;
                            break;
                        }
                    }
                }
            }
            components = aiPanel.getComponents();
            for (int i = 1; i < 9; i++) {
                String name = "aiName" + i;
                for (Component child : components) {
                    if (child instanceof JLabel) {
                        JLabel label = (JLabel) child;
                        if (name.equals(label.getName())) {
                            label.setText(getValueOfXML(reply, "AnalogInput" + i, "Name"));;
                            break;
                        }
                    }
                }
                String value = "aiValue" + i;
                for (Component child : components) {
                    if (child instanceof JLabel) {
                        JLabel label = (JLabel) child;
                        if (value.equals(label.getName())) {
                            label.setText(getValueOfXML(reply, "AnalogInput" + i, "Value"));;
                            break;
                        }
                    }
                }
            }
            components = tiPanel.getComponents();
            for (int i = 1; i < 9; i++) {
                String name = "tiName" + i;
                for (Component child : components) {
                    if (child instanceof JLabel) {
                        JLabel label = (JLabel) child;
                        if (name.equals(label.getName())) {
                            label.setText(getValueOfXML(reply, "TemperatureInput" + i, "Name"));;
                            break;
                        }
                    }
                }
                String value = "tiValue" + i;
                for (Component child : components) {
                    if (child instanceof JLabel) {
                        JLabel label = (JLabel) child;
                        if (value.equals(label.getName())) {
                            label.setText(getValueOfXML(reply, "TemperatureInput" + i, "Value"));;
                            break;
                        }
                    }
                }
            }
        } else if (topic.equals(notificationsTopic)) {
            int startIndex = 0;
            int endIndex = reply.indexOf(">", startIndex);
            notificationLabel.setText(reply.substring(startIndex, endIndex));
            startIndex = endIndex+1;
            endIndex = reply.indexOf(">", startIndex);
            deviceLabel.setText(reply.substring(startIndex, endIndex));
            startIndex = endIndex+1;
            endIndex = reply.length();
            datetimeLabel.setText(reply.substring(startIndex, endIndex));
        }
    }

    public void deliveryComplete(IMqttDeliveryToken imdt) {
        //throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.

    }

    public String getValueOfXML(String xmlString, String searchedString, String searchedSubstring) {
        int startIndex = xmlString.indexOf("<" + searchedString + ">");
        startIndex = xmlString.indexOf("<" + searchedSubstring + ">", startIndex) + ("<" + searchedSubstring + ">").length();
        int endIndex = xmlString.indexOf("</" + searchedSubstring + ">", startIndex);
        String result = xmlString.substring(startIndex, endIndex);
        return result;
    }

}
